CREATE TABLE FORM_FIELD_PROPERTY_TYPE (
	ID_FORM_FIELD_PROPERTY_TYPE NUMBER NOT NULL,
	DESCRIPTION VARCHAR2(100 CHAR),
	INTERNAL_DESCRIPTION VARCHAR2(100 CHAR),
    SORT NUMBER,
	ACTIVE VARCHAR2 (1 CHAR),
	CONSTRAINT FORM_FIELD_PROPERTY_TYPE_PK PRIMARY KEY (ID_FORM_FIELD_PROPERTY_TYPE)
);

CREATE SEQUENCE FORM_FIELD_PROPERTY_TYPE_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

ALTER TABLE FORM_FIELD_PROPERTY_TYPE
ADD OWNER_TYPE VARCHAR2(3 CHAR);

ALTER TABLE FORM_FIELD_PROPERTY
ADD TYPE NUMBER;

ALTER TABLE FORM_FIELD_PROPERTY
DROP CONSTRAINT FORM_FIELD_PROPERTY_UNIQUE;

DROP INDEX FORM_FIELD_PROPERTY_UNIQUE;

ALTER TABLE FORM_FIELD_PROPERTY
ADD CONSTRAINT FORM_FIELD_PROPERTY_UNIQUE UNIQUE (APPLICATION_ID, VIEW_ID, TYPE, TABLE_NAME, COLUMN_NAME);

CREATE OR REPLACE VIEW V_FORM_FIELD_PROPERTY AS (
  SELECT F.ID_FORM_FIELD_PROPERTY, F.APPLICATION_ID, F.VIEW_ID, F.TYPE, F.TABLE_NAME, F.COLUMN_NAME, F.CAPTION_KEY, F.POSITION, F.WIDTH, F.HEIGHT, 
  F.VISIBLE, F.ENABLED, F.REQUIRED, F.ACT, F.COLUMN_1, F.COLUMN_2, F.ROW_1, F.ROW_2,
  NA.OPIS AS APLICATION_OPIS, NA.INTERNI_OPIS AS APLICATION_INTERNI_OPIS, FT.DESCRIPTION AS TYPE_DESCRIPTION, FT.INTERNAL_DESCRIPTION AS TYPE_INTERNAL_DESCRIPTION
	FROM FORM_FIELD_PROPERTY F
  LEFT OUTER JOIN NNAPLICATION NA ON F.APPLICATION_ID = NA.SIFRA
  LEFT OUTER JOIN FORM_FIELD_PROPERTY_TYPE FT ON FT.ID_FORM_FIELD_PROPERTY_TYPE = F.TYPE
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1102, SYSDATE, '5.5', 1022, 'Form field prop type')
;
