ALTER TABLE WAITLIST
DROP COLUMN BERTH_LENGTH;

ALTER TABLE WAITLIST
ADD BERTH_LENGTH_DESC VARCHAR2(100 CHAR)
;

DROP VIEW V_WAITLIST
;

CREATE OR REPLACE VIEW V_WAITLIST AS (
SELECT W.ID_WAITLIST, W.NNLOCATION_ID, W.ID_LASTNIKA, W.ID_PLOVILA, W.ID_TYPE, W.AREA, W.ID_PRIVEZ, W.DATE_FROM, W.DATE_TO, W.LENGTH_OF_STAY, W.STATUS, W.DATE_CREATED, W.USER_CREATED, W.USER_COMMENT,
WT.DESCRIPTION AS TYPE_DESCRIPTION, P.IME AS BOAT_NAME, NT.OPIS AS BOAT_TYPE, P.DOLZINA AS BOAT_LENGTH, P.SIRINA AS BOAT_WIDTH, W.BERTH_LENGTH_DESC, NO.OPIS AS AREA_DESCRIPTION, NP.N_PRIVEZA AS BERTH_DESCRIPTION,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER, 
VK.OPIS AS OWNER_TYPE, K.VRSTA
FROM WAITLIST W
LEFT OUTER JOIN WAITLIST_TYPE WT ON WT.ID_WAITLIST_TYPE = W.ID_TYPE
LEFT OUTER JOIN PLOVILA P ON P.ID = W.ID_PLOVILA
LEFT OUTER JOIN KUPCI K ON K.ID = W.ID_LASTNIKA
LEFT OUTER JOIN NNOBJEKT NO ON NO.SIFRA = W.AREA
LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = W.ID_PRIVEZ 
LEFT OUTER JOIN NNTIP NT ON NT.SIFRA = P.NTIP
LEFT OUTER JOIN NNVRSKUP VK ON VK.SIFRA = K.VRSTA
)
;

DROP VIEW V_RESERVATION;

CREATE OR REPLACE VIEW V_RESERVATION AS (
  SELECT RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR, RE.DATUM_REZERVACIJE, RE.DATUM_DO, RE.PRIVEZ, RE.ID_PRIVEZ, RE.ODPOVED, RE.HOURLY, RE.CHECKIN_STATUS, RE.CHECKIN_TIME, RE.CHECKOUT_TIME, RE.TIP_REZERVAC,
  NNPR.NNLOCATION_ID, DE.ID_REZERVAC_DETAIL AS REZERVAC_DETAIL_ID, DE.DATUM_OD AS REZERVAC_DETAIL_DATUM_OD, DE.DATUM_DO AS REZERVAC_DETAIL_DATUM_DO, DE.STATUS_REZERVAC AS REZERVAC_DETAIL_STATUS, DE.COMPLETE AS REZERVAC_DETAIL_COMPLETE,
  DE.TIME_FROM AS REZERVAC_DETAIL_TIME_FROM, DE.TIME_TO AS REZERVAC_DETAIL_TIME_TO, NNR.OBJEKT AS REZERVAC_PRIVEZ_OBJEKT, NNR.KATEGORIJA AS REZERVAC_PRIVEZ_KATEGORIJA,
  NND.N_PRIVEZA AS REZERVAC_DETAIL_PRIVEZ, NND.ID_PRIVEZ AS REZERVAC_DETAIL_ID_PRIVEZ, NND.OCCUPANCY_STATISTICS AS REZERVAC_DETAIL_OCC_STAT, NNPD.NNLOCATION_ID AS REZERVAC_DETAIL_NNLOCATION_ID, 
  KU.IME AS KUPCI_IME, KU.PRIIMEK AS KUPCI_PRIIMEK,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
  THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
  ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO,
  (CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KU.IME || ' ' || KU.PRIIMEK) ELSE (KU.PRIIMEK || ' ' || KU.IME) END) END) AS OWNER,
  (CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DATUM_ZAVAROVANJE ELSE PL.DATUM_ZAVAROVANJE END) AS DATUM_ZAVAROVANJE,
  (CASE WHEN RE.STATUS_REZERVAC IN (0, 1, 2) THEN 'Y' ELSE 'N' END) AS RECEIVED,
  (CASE WHEN RE.STATUS_REZERVAC = 0 THEN 'Y' ELSE 'N' END) AS DEPARTED
  FROM REZERVAC RE
  JOIN REZERVAC_DETAIL DE ON RE.ID = DE.ID_REZERVAC
  LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
  LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
  LEFT OUTER JOIN NNPRIVEZ NND ON NND.ID_PRIVEZ = DE.ID_PRIVEZ
  LEFT OUTER JOIN NNPOMOL NNPD ON NNPD.SIFRA = NND.KATEGORIJA
  LEFT OUTER JOIN NNPRIVEZ NNR ON NNR.ID_PRIVEZ = RE.ID_PRIVEZ
  LEFT OUTER JOIN NNPOMOL NNPR ON NNPR.SIFRA = NNR.KATEGORIJA
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1845, SYSDATE, '5.5', 1765, 'Waitlist')
;
