ALTER TABLE EMAIL_TEMPLATE
ADD CONFIDENTIAL VARCHAR2(1 CHAR);

ALTER TABLE EMAILS
ADD CONFIDENTIAL VARCHAR2(1 CHAR);

DROP VIEW V_EMAIL_TEMPLATE;

CREATE OR REPLACE VIEW V_EMAIL_TEMPLATE AS
SELECT ET.ID_EMAIL_TEMPLATE, ET.VALUE, ET.CONTENT, ET.NAME, ET.RECEIVER, ET.RECEIVER_CC, ET.RECEIVER_BCC, ET.SENDER, ET.LANGUAGE_CODE,
ET.DATE_CHANGED, ET.USER_CHANGED, ET.DATE_CREATED, ET.USER_CREATED, ET.ACT, ET.SUBJECT, ET.TYPE, ET.USER_SELECTABLE, ET.NNLOCATION_ID, ET.CONFIDENTIAL,
ETT.OPIS AS TYPE_OPIS, ETT.INTERNI_OPIS AS TYPE_INTERNI_OPIS, ETT.TEMPLATE_SUBTYPE AS SUBTYPE
FROM EMAIL_TEMPLATE ET
LEFT OUTER JOIN NNEMAIL_TEMPLATE_TYPE ETT ON ET.TYPE = ETT.SIFRA;

DROP VIEW V_EMAIL;

CREATE OR REPLACE VIEW V_EMAIL
AS (
SELECT E.ID_EMAIL, E.DATUM_KREIRANJA, E.USER_KREIRANJA, E.ZADEVA, E.POSILJATELJ, E.STATUS, E.DATUM_POSILJANJA, E.AVTOMATSKO_KREIRANJE, E.PREJEMNIK_CC, 
E.PREJEMNIK_BCC, E.PREJEMNIK, E.TEKST, E.MESSAGE_ID, E.DATUM_PREJEMA, E.PREBRANO, E.STATUS_MESSAGE, E.CHECKED_ERROR, E.REFERENCE_ID, E.REFERENCE_TABLE, E.NNLOCATION_ID, E.CONFIDENTIAL,
K.ID AS KUPCI_ID, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.ID_MEMBER AS KUPCI_ID_MEMBER,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM EMAILS E
LEFT OUTER JOIN (SELECT ID_KUPCA, ID_EMAIL, NPISMO, RANK() OVER (PARTITION BY ID_EMAIL ORDER BY ID_OPOMINI ASC) RNK FROM OPOMINI) O ON (O.ID_EMAIL = E.ID_EMAIL AND O.RNK = 1 AND O.NPISMO = 'E')
LEFT OUTER JOIN KUPCI K ON O.ID_KUPCA = K.ID
);

DROP VIEW V_KUPCI_EMAIL;

CREATE OR REPLACE VIEW V_KUPCI_EMAIL
AS (
SELECT O.ID_OPOMINI AS ID, O.LASTNIK_OBVESCEN, K.ID AS KUPCI_ID, K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.MANAGER AS KUPCI_MANAGER, K.VRSTA AS KUPCI_VRSTA, 
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
E.ID_EMAIL AS EMAIL_ID_EMAIL, E.DATUM_KREIRANJA AS EMAIL_DATUM_KREIRANJA, E.USER_KREIRANJA AS EMAIL_USER_KREIRANJA,
E.TEKST AS EMAIL_TEKST, E.ZADEVA AS EMAIL_ZADEVA, E.POSILJATELJ AS EMAIL_POSILJATELJ, E.PREJEMNIK AS EMAIL_PREJEMNIK, E.STATUS AS EMAIL_STATUS, E.DATUM_POSILJANJA AS EMAIL_DATUM_POSILJANJA, E.AVTOMATSKO_KREIRANJE
AS EMAIL_AVTOMATSKO_KREIRANJE, E.PREJEMNIK_CC AS EMAIL_PREJEMNIK_CC, E.PREJEMNIK_BCC AS EMAIL_PREJEMNIK_BCC, E.PREBRANO AS EMAIL_PREBRANO, E.STATUS_MESSAGE AS EMAIL_STATUS_MESSAGE, E.NNLOCATION_ID AS EMAIL_NNLOCATION_ID,
E.CONFIDENTIAL AS EMAIL_CONFIDENTIAL
FROM OPOMINI O
LEFT OUTER JOIN KUPCI K ON K.ID = O.ID_KUPCA
LEFT OUTER JOIN EMAILS E ON E.ID_EMAIL = O.ID_EMAIL
WHERE O.NPISMO = (SELECT NPISMO FROM NPISMO N WHERE N.NPISMO_TYPE = 'EMAIL')
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2133, SYSDATE, '5.5', 2053, 'Confidential emails')
;
